<template>
	<view>
		<uni-segmented-control :current="current" :values="items" @clickItem="onClickItem">
		</uni-segmented-control>
		<view v-if="current === 0" class="headerstyle">
			<view class="itemstyle">
				<uni-forms style="margin-left: 2%;margin-top: 20px;" label-width="180">
					<uni-forms-item :label="label"></uni-forms-item>
					<uni-forms-item label="单据类型：调拨申请单"></uni-forms-item>
					<uni-forms-item label="内箱码：">
						<uni-easyinput type="text" placeholder="请扫描内箱码" ref='midInput' :focus="focus"
							v-model="innerCode" @input="innercodeInput" />
					</uni-forms-item>
					<uni-forms-item :label="matCode"></uni-forms-item>
					<uni-forms-item :label="matName"></uni-forms-item>
					<uni-forms-item :label="currentQty"></uni-forms-item>
					<uni-forms-item :label="orderQty"></uni-forms-item>
					<uni-forms-item :label="scanQty"></uni-forms-item>
				</uni-forms>
			</view>
		</view>
		<view v-if="current === 1" class="headerstyle">
			<view class="itemstyle">
				<uni-forms label-width="180">
					<uni-forms-item label="区域"><uni-data-select v-model="value"
							:localdata="range"></uni-data-select></uni-forms-item>
					<uni-forms-item label="楼层"><uni-data-select v-model="floor"
							:localdata="floorrange"></uni-data-select></uni-forms-item>
				</uni-forms>
				<uni-list :border="true">
					<uni-list-item direction="column" v-for="(item,index) in orderInfo" :key="item.dtlId">
						<template v-slot:body>
							<view class="uni-list-box">
								<button type="primary" style="position: absolute;right: 1%;" size="mini"
									@click="outbound(item.matCode)">出库</button>
								<view class="uni-content">
									<view style="font-size: 18px;">物料编码：{{item.matCode}}</view>
									<view style="font-size: 18px;">单据号：{{orderNo}}</view>
									<view style="font-size: 18px;">物料名称：{{item.matName}}</view>
									<view style="font-size: 18px;">单据数量：{{item.totalQty}}</view>
									<view style="font-size: 18px;">已分配数量：{{item.processQty}}</view>
									<view style="font-size: 18px;">出库数量：{{item.outQty}}</view>
								</view>
							</view>
						</template>
					</uni-list-item>
				</uni-list>
			</view>
		</view>
		<view v-if="current === 2" class="headerstyle">
			<view class="itemstyle">
				<uni-forms label-width="120">
					<uni-forms-item label="楼层">
						<uni-data-select v-model="printfloor" :localdata="printfloorrange"></uni-data-select>
					</uni-forms-item>
					<uni-forms-item label="内箱标签">
						<uni-easyinput type="text" :focus="tagFocus" v-model="tag" placeholder="请扫描内箱标签" ref='midInput'
							@input="tagInput" />
					</uni-forms-item>
					<uni-forms-item :label="tagmatCode"></uni-forms-item>
					<uni-forms-item :label="tagmatName"></uni-forms-item>
					<uni-forms-item :label="tagQty"></uni-forms-item>
					<uni-forms-item label="拆分数量">
						<uni-easyinput type="number" v-model="number" placeholder="请输入拆分数量" ref='midInput'
							:focus="numberFocus" />
					</uni-forms-item>
					<uni-forms-item>
						<button @click="printTag" type="primary" size="default" style="margin-top: 2%;">打印标签</button>
					</uni-forms-item>
				</uni-forms>
			</view>
		</view>
		<view v-if="current === 3" class="headerstyle">
			<view class="itemstyle">
				<uni-forms label-width="120">
					<uni-forms-item label="托盘条码">
						<uni-easyinput type="text" :focus="!istrue" v-model="barcode" placeholder="请扫描托盘条码"
							ref='midInput' @input="inputChangebarcode" />
					</uni-forms-item>
					<uni-forms-item label="地址条码">
						<uni-easyinput type="text" v-model="address" placeholder="请扫描地址条码" ref='midInput'
							:focus="istrue" />
					</uni-forms-item>
					<uni-forms-item>
						<button @click="inbound" type="primary" size="default" style="margin-top: 2%;">入库</button>
					</uni-forms-item>
				</uni-forms>
			</view>
		</view>
		<u-toast ref="uToast" />
	</view>
</template>

<script>
	const innerAudioContext = uni.createInnerAudioContext();
	export default {
		data() {
			return {
				items: ['出库条码扫描', '明细', '拆分', '入库'],
				current: 0,
				orderNo: "",
				orderInfo: [],
				label: "",
				innerCode: "",
				matCode: "物料编码：",
				matName: "物料名称：",
				orderQty: "需求数量：",
				currentQty: "已扫数量：",
				scanQty: "累计数量：",
				tagFocus: true,
				numberFocus: false,
				focus: true,
				tag: "",
				number: "",
				tagmatCode: "物料编码：",
				tagmatName: "物料名称：",
				tagQty: "包装数量：",
				value: "KB",
				range: [{
						value: "KB",
						text: "KB"
					},
					{
						value: "ZB",
						text: "ZB"
					}
				],
				floor: "F2",
				floorrange: [{
						value: "F2",
						text: "F2"
					},
					{
						value: "F3",
						text: "F3"
					},
					{
						value: "F4",
						text: "F4"
					},
					{
						value: "F7",
						text: "F7"
					}
				],
				printfloor: "F2",
				printfloorrange: [{
						value: "F2",
						text: "F2"
					},
					{
						value: "F2-ZB",
						text: "F2-ZB"
					},
					{
						value: "F3",
						text: "F3"
					},
					{
						value: "F4",
						text: "F4"
					},
					{
						value: "F7",
						text: "F7"
					},
					{
						value: "F7-2",
						text: "F7-2"
					}
				],
				barcode: "",
				address: "",
				istrue: false
			}
		},
		onLoad(res) {
			this.orderNo = res.orderNo;
			this.label = "单据编号：" + this.orderNo;
			this.getData();
		},
		methods: {
			voiceSpeech(src) {
				innerAudioContext.src = src; // '../../static/success.mp3';
				innerAudioContext.play();
			},
			updateFocus() {
				this.$nextTick(() => {
					this.innerCode = '';
					if (!this.focus) {
						this.focus = true;
					}
				});
			},
			inbound() {
				if (this.barcode.length == 0) {
					this.$refs.uToast.show({
						title: "请扫描托盘号",
						type: "error"
					})
					return;
				}
				if (this.address.length == 0) {
					this.$refs.uToast.show({
						title: "请扫描地址条码",
						type: "error"
					})
					return;
				}
				var postData = {
					MainData: {
						"barcode": this.barcode,
						"startPoint": this.address
					}
				}
				this.$u.post('/api/Inbound/RequestInbound', postData).then(res => {
					if (res.status) {
						uni.$showMsg(res.message);
						this.barcode = "";
						this.address = "";
						this.istrue = false;
					} else {
						this.$refs.uToast.show({
							title: res.message,
							type: "error"
						})
					}
				}).catch(err => {
					this.$refs.uToast.show({
						title: err.message,
						type: "error"
					})
				})
			},
			inputChangebarcode() {
				this.istrue = false;
				this.$nextTick(function(x) {
					if (this.barcode != '') {
						this.istrue = true;
					}
				})
			},
			onClickItem(e) {
				this.focus = false;
				this.addressFocus = false;
				if (this.current !== e.currentIndex) {
					this.current = e.currentIndex;
					if (this.current == 1) {
						this.getData();
					}
				}
			},
			getData() {
				var postData = {
					MainData: {
						orderNo: this.orderNo
					},
				}
				this.$u.post('/api/ErpOrder/GetAllocationOrderInfo', postData).then((res) => {
					if (res.status) {
						this.orderInfo = res.data;
						if (this.orderInfo.length > 3) {
							this.loadVisible = true;
						}
					}
				})
			},
			innercodeInput() {
				this.$nextTick(() => {
					if (this.innerCode == "") {
						return;
					}
					var innerCode = this.innerCode;
					setTimeout(() => {
						this.innerCode = "";
					}, 10);

					// this.focus = false;
					if (innerCode.split('|').length == 7) {
						var postData = {
							MainData: {
								orderNo: this.orderNo,
								innerCode: innerCode
							},
						}
						this.$u.post('/api/ErpOrder/UpdateAlloctionOrder', postData).then((res) => {
							if (res.status) {
								this.matCode = "物料编码：" + res.data.matCode;
								this.matName = "物料名称：" + res.data.matName;
								this.orderQty = "需求数量：" + res.data.orderQty;
								this.currentQty = "已扫数量：" + res.data.currentQty;
								this.scanQty = "累计数量：" + res.data.scanQty;
								if (res.message) {
									this.$refs.uToast.show({
										title: res.message,
										type: "error"
									})
									// setTimeout(this.updateFocus,200);
									setTimeout(() => {
										this.voiceSpeech('../../static/fail.mp3');
									}, 100);
									return;
								}
								// setTimeout(this.updateFocus,200);
								setTimeout(() => {
									this.voiceSpeech('../../static/success.mp3');
								}, 100);
							} else {
								// this.innerCode = "";
								this.$refs.uToast.show({
									title: res.message,
									type: "error"
								})
								// setTimeout(this.updateFocus,200);
								setTimeout(() => {
									this.voiceSpeech('../../static/fail.mp3');
								}, 100);
							}
						})
					} else {
						// this.innerCode = "";
						this.$refs.uToast.show({
							title: "内箱码扫描错误",
							type: "error"
						})
						// setTimeout(this.updateFocus,200);
						setTimeout(() => {
							this.voiceSpeech('../../static/fail.mp3');
						}, 100);
					}
					// this.innerCode = "";
				})
			},
			tagInput() {
				this.$nextTick(() => {
					var tagInfos = this.tag.split('|');
					if (tagInfos.length == 7) {
						this.tagmatCode = "物料编码：" + tagInfos[1];
						this.tagQty = "物料数量：" + tagInfos[5];
					} else {
						this.$refs.uToast.show({
							title: "内箱码扫描错误",
							type: "error"
						})
					}
					this.numberFocus = true;
				})
			},
			printTag() {
				if (this.tag == "") {
					this.$refs.uToast.show({
						title: "请扫描内箱标签",
						type: "error"
					})
					return;
				}
				if (this.number <= 0) {
					this.$refs.uToast.show({
						title: "请输入数量",
						type: "error"
					})
					return;
				}
				var postData = {
					MainData: {
						tag: this.tag,
						number: this.number,
						floor: this.printfloor
					}
				}
				this.$u.post('/api/StockOperate/PrintTag', postData).then(res => {
					if (res.status) {
						this.$refs.uToast.show({
							title: "打印成功",
							type: "success"
						})
						this.tagmatCode = "物料编码：";
						this.tagQty = "包装数量：";
						this.tag = "";
					} else {
						this.$refs.uToast.show({
							title: res.message,
							type: "error"
						})
					}
				})
			},
			outbound(code) {
				var postData = {
					MainData: {
						matCode: code,
						orderNo: this.orderNo,
						system: this.value,
						floor: this.floor
					}
				}
				this.$u.post('/api/ErpOrder/AllocationOrderOutbound', postData).then(res => {
					if (res.status) {
						this.$refs.uToast.show({
							title: "成功",
							type: "success"
						})
						this.getData();
					} else {
						this.$refs.uToast.show({
							title: res.message,
							type: "error"
						})
					}
				})
			}
		}
	}
</script>

<style lang="scss">
	@import '@/common/uni-ui.scss';

	.content {
		display: flex;
		height: 150px;
	}

	.content-text {
		font-size: 14px;
		color: #666;
	}

	.itemstyle {
		margin-top: 20px;
		margin-left: 5%;
	}

	.headerstyle {
		width: 90%;
	}
</style>